package ink.wgink.module.wechat.pay.pojo.v3.refund;

import java.util.ArrayList;
import java.util.List;

/**
 * @ClassName: Refund
 * @Description: 退款
 * @Author: wanggeng
 * @Date: 2022/11/11 18:49
 * @Version: 1.0
 */
public class Refund {

    private String out_refund_no;
    private String reason;
    private String notify_url;
    private String funds_account;
    private Amount amount;
    private List<GoodsDetail> goods_detail;

    public String getOut_refund_no() {
        return out_refund_no == null ? "" : out_refund_no.trim();
    }

    public void setOut_refund_no(String out_refund_no) {
        this.out_refund_no = out_refund_no;
    }

    public String getReason() {
        return reason == null ? "" : reason.trim();
    }

    public void setReason(String reason) {
        this.reason = reason;
    }

    public String getNotify_url() {
        return notify_url == null ? "" : notify_url.trim();
    }

    public void setNotify_url(String notify_url) {
        this.notify_url = notify_url;
    }

    public String getFunds_account() {
        return funds_account == null ? "" : funds_account.trim();
    }

    public void setFunds_account(String funds_account) {
        this.funds_account = funds_account;
    }

    public Amount getAmount() {
        return amount;
    }

    public void setAmount(Amount amount) {
        this.amount = amount;
    }

    public List<GoodsDetail> getGoods_detail() {
        return goods_detail == null ? new ArrayList() : goods_detail;
    }

    public void setGoods_detail(List<GoodsDetail> goods_detail) {
        this.goods_detail = goods_detail;
    }

    public static class Amount {
        /**
         * 退款金额<br/>
         * 退款金额，单位为分，只能为整数，不能超过原订单支付金额。
         */
        private Integer refund;
        /**
         * 退款出资账户及金额<br/>
         * 退款需要从指定账户出资时，传递此参数指定出资金额（币种的最小单位，只能为整数）。<br/>
         * 同时指定多个账户出资退款的使用场景需要满足以下条件：<br/>
         * 1、未开通退款支出分离产品功能；<br/>
         * 2、订单属于分账订单，且分账处于待分账或分账中状态。<br/>
         * 参数传递需要满足条件：<br/>
         * 1、基本账户可用余额出资金额与基本账户不可用余额出资金额之和等于退款金额；<br/>
         * 2、账户类型不能重复。<br/>
         * 上述任一条件不满足将返回错误
         */
        private List<AmountFrom> from;
        /**
         * 原订单金额<br/>
         * 原支付交易的订单总金额，单位为分，只能为整数。
         */
        private Integer total;
        /**
         * 退款币种<br/>
         * 符合ISO 4217标准的三位字母代码，目前只支持人民币：CNY。
         */
        private String currency;

        public Integer getRefund() {
            return refund == null ? 0 : refund;
        }

        public void setRefund(Integer refund) {
            this.refund = refund;
        }

        public List<AmountFrom> getFrom() {
            return from == null ? new ArrayList() : from;
        }

        public void setFrom(List<AmountFrom> from) {
            this.from = from;
        }

        public Integer getTotal() {
            return total == null ? 0 : total;
        }

        public void setTotal(Integer total) {
            this.total = total;
        }

        public String getCurrency() {
            return currency == null ? "" : currency.trim();
        }

        public void setCurrency(String currency) {
            this.currency = currency;
        }
    }

}
