package ink.wgink.module.wechat.pay.remote.v3;

import com.alibaba.fastjson2.JSONObject;
import ink.wgink.annotation.rpc.rest.RemoteService;
import ink.wgink.annotation.rpc.rest.method.RemoteGetMethod;
import ink.wgink.annotation.rpc.rest.method.RemotePostMethod;
import ink.wgink.annotation.rpc.rest.params.RemoteHeaderParams;
import ink.wgink.annotation.rpc.rest.params.RemoteJsonBodyParams;
import ink.wgink.annotation.rpc.rest.params.RemotePathParams;
import ink.wgink.annotation.rpc.rest.params.RemoteServerParams;
import ink.wgink.module.wechat.pay.pojo.v3.refund.RefundResult;

/**
 * @ClassName: IRefundsRemoteService
 * @Description: 退款
 * @Author: wanggeng
 * @Date: 2022/11/10 21:30
 * @Version: 1.0
 */
@RemoteService
public interface IRefundsRemoteService {

    /**
     * 申请退款
     *
     * @param server
     * @param authorization
     * @param serialNumber
     * @param body
     * @return
     */
    @RemotePostMethod("/v3/refund/domestic/refunds")
    RefundResult refund(@RemoteServerParams String server,
                        @RemoteHeaderParams(IPayRemoteService.HEADER_AUTHORIZATION) String authorization,
                        @RemoteHeaderParams(IPayRemoteService.HEADER_WECHATPAY_SERIAL) String serialNumber,
                        @RemoteJsonBodyParams JSONObject body);


    @RemoteGetMethod("/v3/refund/domestic/refunds/{outRefundNo}")
    RefundResult get(@RemoteServerParams String server,
                     @RemoteHeaderParams(IPayRemoteService.HEADER_AUTHORIZATION) String authorization,
                     @RemoteHeaderParams(IPayRemoteService.HEADER_WECHATPAY_SERIAL) String serialNumber,
                     @RemotePathParams("out_refund_no") String outRefundNo);

}
