package ink.wgink.module.wechat.pay.service.v3.nav.impl;

import com.alibaba.fastjson.JSONObject;
import ink.wgink.module.wechat.pay.enums.PayAuthorizationTypeEnum;
import ink.wgink.module.wechat.pay.pojo.v3.jsapi.pojo.PayPlaceOrder;
import ink.wgink.module.wechat.pay.pojo.v3.nav.PayCodeUrl;
import ink.wgink.module.wechat.pay.remote.v3.IOrderPayRemoteService;
import ink.wgink.module.wechat.pay.service.BasePayService;
import ink.wgink.module.wechat.pay.service.v3.nav.INativeService;
import ink.wgink.module.wechat.pay.utils.v3.PayOrderUtil;
import ink.wgink.properties.wechat.miniapp.MiniappProperties;
import ink.wgink.util.BeanPropertyCheckUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.web.bind.annotation.RequestMethod;

/**
 * @ClassName: NativeServiceImpl
 * @Description: native支付
 * @Author: wanggeng
 * @Date: 2022/11/10 17:53
 * @Version: 1.0
 */
@Service
public class NativeServiceImpl extends BasePayService implements INativeService {

    @Autowired
    private MiniappProperties miniappProperties;
    @Autowired
    private IOrderPayRemoteService orderPayRemoteService;

    @Override
    public String placeOrder(PayPlaceOrder payPlaceOrder) throws Exception {
        payPlaceOrder.setAppid(miniappProperties.getAppKey());
        payPlaceOrder.setMchid(payProperties.getMchid());
        BeanPropertyCheckUtil.checkField(payPlaceOrder);
        String urlSuffix = "/v3/pay/transactions/native";

        LOG.debug("获得证书序列号");
        String serialNumber = getSerialNumber();

        LOG.debug("调用微信支付，发起预支付");
        JSONObject body = PayOrderUtil.getPlaceOrderJsonObject(payPlaceOrder);
        String authorization = getAuthorization(RequestMethod.POST, urlSuffix, serialNumber, payProperties, body.toString(), PayAuthorizationTypeEnum.WECHATPAY2_SHA256_RSA2048);

        LOG.debug("请求获得结果");
        PayCodeUrl payCodeUrl = orderPayRemoteService.placeOrderNative(getPayBaseUrl(), authorization, serialNumber, body);

        return payCodeUrl.getCode_url();
    }

}
