package ink.wgink.module.wechat.pay.service.v3.refund;

import ink.wgink.module.wechat.pay.pojo.v3.refund.Refund;
import ink.wgink.module.wechat.pay.pojo.v3.refund.RefundResult;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * @ClassName: IRefundsService
 * @Description: 退款
 * @Author: wanggeng
 * @Date: 2022/11/10 21:29
 * @Version: 1.0
 */
public interface IRefundService {

    /**
     * 退款
     *
     * @param transactionId
     * @param refund
     * @return
     */
    RefundResult refund(String transactionId, Refund refund) throws Exception;

    /**
     * 业务订单退款
     *
     * @param businessOrderId
     * @param refund
     * @return
     */
    RefundResult refundByBusinessOrder(String businessOrderId, Refund refund) throws Exception;

    /**
     * 详情
     *
     * @param businessRefundId
     * @return
     * @throws Exception
     */
    RefundResult getByBusinessRefundId(String businessRefundId) throws Exception;

    /**
     * 通知
     *
     * @param request
     * @param response
     * @param nonce
     * @param timestamp
     * @param wechatpaySignature
     */
    void notice(HttpServletRequest request, HttpServletResponse response, String nonce, String timestamp, String wechatpaySignature) throws IOException;
}
